package wap.menu.sample;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "wap.menu.sample", "wap.menu.sample.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "wap.menu.sample", "wap.menu.sample.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "wap.menu.sample.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public wap.menu.wappmenu _z = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b = null;
public anywheresoftware.b4a.objects.ButtonWrapper _c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _d = null;
public anywheresoftware.b4a.objects.ButtonWrapper _e = null;
public anywheresoftware.b4a.objects.ButtonWrapper _tl = null;
public anywheresoftware.b4a.objects.ButtonWrapper _tr = null;
public anywheresoftware.b4a.objects.ButtonWrapper _bl = null;
public anywheresoftware.b4a.objects.ButtonWrapper _br = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _p = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _s = null;
public wap.menu.sample.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="z.Initialize(Me,\"z\",Activity)";
mostCurrent._z._initialize(mostCurrent.activityBA,main.getObject(),"z",mostCurrent._activity);
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="TL.Initialize(\"TL\")";
mostCurrent._tl.Initialize(mostCurrent.activityBA,"TL");
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="TR.Initialize(\"TR\")";
mostCurrent._tr.Initialize(mostCurrent.activityBA,"TR");
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="BL.Initialize(\"BL\")";
mostCurrent._bl.Initialize(mostCurrent.activityBA,"BL");
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="BR.Initialize(\"BR\")";
mostCurrent._br.Initialize(mostCurrent.activityBA,"BR");
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="Activity.AddView(TL,0,0,40%x,20%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._tl.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="Activity.AddView(TR,60%x,0,40%x,20%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._tr.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (60),mostCurrent.activityBA),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="Activity.AddView(BL,0,55%y,40%x,20%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._bl.getObject()),(int) (0),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (55),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="Activity.AddView(BR,60%x,55%y,40%x,20%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._br.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (60),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (55),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="TL.Text=\"3x2 cells, 3sec, 10dip pad.\"";
mostCurrent._tl.setText((Object)("3x2 cells, 3sec, 10dip pad."));
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="TR.Text=\"2x3 cells, 10sec, 2dip pad.\"";
mostCurrent._tr.setText((Object)("2x3 cells, 10sec, 2dip pad."));
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="BL.Text=\"2x2 cells, 5sec, 20dip pad.\"";
mostCurrent._bl.setText((Object)("2x2 cells, 5sec, 20dip pad."));
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="BR.Text=\"3x1 cells, 1 sec, 5dip pad\"";
mostCurrent._br.setText((Object)("3x1 cells, 1 sec, 5dip pad"));
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="b.Initialize(\"b\")";
mostCurrent._b.Initialize(mostCurrent.activityBA,"b");
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="c.Initialize(\"c\")";
mostCurrent._c.Initialize(mostCurrent.activityBA,"c");
RDebugUtils.currentLine=131093;
 //BA.debugLineNum = 131093;BA.debugLine="d.Initialize(\"d\")";
mostCurrent._d.Initialize(mostCurrent.activityBA,"d");
RDebugUtils.currentLine=131094;
 //BA.debugLineNum = 131094;BA.debugLine="d.Initialize(\"d\")";
mostCurrent._d.Initialize(mostCurrent.activityBA,"d");
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="s.Initialize(\"s\")";
mostCurrent._s.Initialize(mostCurrent.activityBA,"s");
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="Activity.AddView(b,0,90%y,50%x,10%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._b.getObject()),(int) (0),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (90),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (10),mostCurrent.activityBA));
RDebugUtils.currentLine=131097;
 //BA.debugLineNum = 131097;BA.debugLine="b.Text=\"show\"";
mostCurrent._b.setText((Object)("show"));
RDebugUtils.currentLine=131098;
 //BA.debugLineNum = 131098;BA.debugLine="Activity.AddView(c,50%x,90%y,50%x,10%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._c.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (90),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (10),mostCurrent.activityBA));
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="c.Text=\"close\"";
mostCurrent._c.setText((Object)("close"));
RDebugUtils.currentLine=131101;
 //BA.debugLineNum = 131101;BA.debugLine="Activity.AddView(z.AsMainView,0,25%y,100%x,30%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._z._asmainview().getObject()),(int) (0),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (25),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (30),mostCurrent.activityBA));
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_pause"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_pause", new Object[] {_userclosed});
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _b_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("b_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "b_click", null);
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub b_Click";
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="z.Show";
mostCurrent._z._show();
RDebugUtils.currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="End Sub";
return "";
}
public static String  _bl_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("bl_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "bl_click", null);
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub BL_Click";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="z.BackgroundColor=Colors.White";
mostCurrent._z._setbackgroundcolor(anywheresoftware.b4a.keywords.Common.Colors.White);
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="z.TextColor=Colors.Red";
mostCurrent._z._settextcolor(anywheresoftware.b4a.keywords.Common.Colors.Red);
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="z.Animi_Time=5000";
mostCurrent._z._setanimi_time((int) (5000));
RDebugUtils.currentLine=720900;
 //BA.debugLineNum = 720900;BA.debugLine="z.Col_Count=2";
mostCurrent._z._setcol_count((int) (2));
RDebugUtils.currentLine=720901;
 //BA.debugLineNum = 720901;BA.debugLine="z.Row_Count=2";
mostCurrent._z._setrow_count((int) (2));
RDebugUtils.currentLine=720902;
 //BA.debugLineNum = 720902;BA.debugLine="z.Padding=20dip";
mostCurrent._z._setpadding(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (20)));
RDebugUtils.currentLine=720903;
 //BA.debugLineNum = 720903;BA.debugLine="z.StartingPoint=2";
mostCurrent._z._setstartingpoint((int) (2));
RDebugUtils.currentLine=720904;
 //BA.debugLineNum = 720904;BA.debugLine="z.SetLayout";
mostCurrent._z._setlayout();
RDebugUtils.currentLine=720905;
 //BA.debugLineNum = 720905;BA.debugLine="z.OptionsDeleteAll";
mostCurrent._z._optionsdeleteall();
RDebugUtils.currentLine=720906;
 //BA.debugLineNum = 720906;BA.debugLine="If z.OptionsAdd(\"Option #1\",\"1.png\",\"1n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #1","1.png","1n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("1# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720907;
 //BA.debugLineNum = 720907;BA.debugLine="If z.OptionsAdd(\"Option #2\",\"2.png\",\"2n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #2","2.png","2n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("2# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720908;
 //BA.debugLineNum = 720908;BA.debugLine="If z.OptionsAdd(\"Option #3\",\"3.png\",\"3n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #3","3.png","3n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("3# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720909;
 //BA.debugLineNum = 720909;BA.debugLine="If z.OptionsAdd(\"Option #4\",\"4.png\",\"4n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #4","4.png","4n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("4# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720910;
 //BA.debugLineNum = 720910;BA.debugLine="If z.OptionsAdd(\"Option #5\",\"5.png\",\"5n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #5","5.png","5n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("5# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720911;
 //BA.debugLineNum = 720911;BA.debugLine="If z.OptionsAdd(\"Option #6\",\"6.png\",\"6n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #6","6.png","6n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("6# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=720912;
 //BA.debugLineNum = 720912;BA.debugLine="z.OptionsLoad";
mostCurrent._z._optionsload();
RDebugUtils.currentLine=720913;
 //BA.debugLineNum = 720913;BA.debugLine="End Sub";
return "";
}
public static String  _br_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("br_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "br_click", null);
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub BR_Click";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="z.BackgroundColor=Colors.LightGray";
mostCurrent._z._setbackgroundcolor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="z.TextColor=Colors.Blue";
mostCurrent._z._settextcolor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="z.Animi_Time=1000";
mostCurrent._z._setanimi_time((int) (1000));
RDebugUtils.currentLine=786436;
 //BA.debugLineNum = 786436;BA.debugLine="z.Col_Count=3";
mostCurrent._z._setcol_count((int) (3));
RDebugUtils.currentLine=786437;
 //BA.debugLineNum = 786437;BA.debugLine="z.Row_Count=1";
mostCurrent._z._setrow_count((int) (1));
RDebugUtils.currentLine=786438;
 //BA.debugLineNum = 786438;BA.debugLine="z.Padding=5dip";
mostCurrent._z._setpadding(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5)));
RDebugUtils.currentLine=786439;
 //BA.debugLineNum = 786439;BA.debugLine="z.StartingPoint=4";
mostCurrent._z._setstartingpoint((int) (4));
RDebugUtils.currentLine=786440;
 //BA.debugLineNum = 786440;BA.debugLine="z.SetLayout";
mostCurrent._z._setlayout();
RDebugUtils.currentLine=786441;
 //BA.debugLineNum = 786441;BA.debugLine="z.OptionsDeleteAll";
mostCurrent._z._optionsdeleteall();
RDebugUtils.currentLine=786442;
 //BA.debugLineNum = 786442;BA.debugLine="If z.OptionsAdd(\"Option #1\",\"1.png\",\"1n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #1","1.png","1n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("1# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786443;
 //BA.debugLineNum = 786443;BA.debugLine="If z.OptionsAdd(\"Option #2\",\"2.png\",\"2n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #2","2.png","2n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("2# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786444;
 //BA.debugLineNum = 786444;BA.debugLine="If z.OptionsAdd(\"Option #3\",\"3.png\",\"3n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #3","3.png","3n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("3# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786445;
 //BA.debugLineNum = 786445;BA.debugLine="If z.OptionsAdd(\"Option #4\",\"4.png\",\"4n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #4","4.png","4n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("4# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786446;
 //BA.debugLineNum = 786446;BA.debugLine="If z.OptionsAdd(\"Option #5\",\"5.png\",\"5n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #5","5.png","5n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("5# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786447;
 //BA.debugLineNum = 786447;BA.debugLine="If z.OptionsAdd(\"Option #6\",\"6.png\",\"6n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #6","6.png","6n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("6# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=786448;
 //BA.debugLineNum = 786448;BA.debugLine="z.OptionsLoad";
mostCurrent._z._optionsload();
RDebugUtils.currentLine=786449;
 //BA.debugLineNum = 786449;BA.debugLine="End Sub";
return "";
}
public static String  _c_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("c_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "c_click", null);
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub c_Click";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="z.Hide";
mostCurrent._z._hide();
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="End Sub";
return "";
}
public static String  _tl_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("tl_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "tl_click", null);
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub TL_Click";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="z.BackgroundColor=Colors.Yellow";
mostCurrent._z._setbackgroundcolor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="z.TextColor=Colors.Blue";
mostCurrent._z._settextcolor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
RDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="z.Animi_Time=20000";
mostCurrent._z._setanimi_time((int) (20000));
RDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="z.Col_Count=3";
mostCurrent._z._setcol_count((int) (3));
RDebugUtils.currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="z.Row_Count=2";
mostCurrent._z._setrow_count((int) (2));
RDebugUtils.currentLine=589830;
 //BA.debugLineNum = 589830;BA.debugLine="z.Padding=10dip";
mostCurrent._z._setpadding(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)));
RDebugUtils.currentLine=589831;
 //BA.debugLineNum = 589831;BA.debugLine="z.StartingPoint=1";
mostCurrent._z._setstartingpoint((int) (1));
RDebugUtils.currentLine=589832;
 //BA.debugLineNum = 589832;BA.debugLine="z.SetLayout";
mostCurrent._z._setlayout();
RDebugUtils.currentLine=589833;
 //BA.debugLineNum = 589833;BA.debugLine="z.OptionsDeleteAll";
mostCurrent._z._optionsdeleteall();
RDebugUtils.currentLine=589834;
 //BA.debugLineNum = 589834;BA.debugLine="If z.OptionsAdd(\"Option #1\",\"1.png\",\"1n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #1","1.png","1n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("1# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589835;
 //BA.debugLineNum = 589835;BA.debugLine="If z.OptionsAdd(\"Option #2\",\"2.png\",\"2n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #2","2.png","2n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("2# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589836;
 //BA.debugLineNum = 589836;BA.debugLine="If z.OptionsAdd(\"Option #3\",\"3.png\",\"3n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #3","3.png","3n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("3# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589837;
 //BA.debugLineNum = 589837;BA.debugLine="If z.OptionsAdd(\"Option #4\",\"4.png\",\"4n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #4","4.png","4n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("4# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589838;
 //BA.debugLineNum = 589838;BA.debugLine="If z.OptionsAdd(\"Option #5\",\"5.png\",\"5n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #5","5.png","5n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("5# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589839;
 //BA.debugLineNum = 589839;BA.debugLine="If z.OptionsAdd(\"Option #6\",\"6.png\",\"6n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #6","6.png","6n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("6# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=589840;
 //BA.debugLineNum = 589840;BA.debugLine="z.OptionsLoad";
mostCurrent._z._optionsload();
RDebugUtils.currentLine=589843;
 //BA.debugLineNum = 589843;BA.debugLine="End Sub";
return "";
}
public static String  _tr_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("tr_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "tr_click", null);
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub TR_Click";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="z.BackgroundColor=Colors.Blue";
mostCurrent._z._setbackgroundcolor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
RDebugUtils.currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="z.TextColor=Colors.Yellow";
mostCurrent._z._settextcolor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
RDebugUtils.currentLine=655363;
 //BA.debugLineNum = 655363;BA.debugLine="z.Animi_Time=10000";
mostCurrent._z._setanimi_time((int) (10000));
RDebugUtils.currentLine=655364;
 //BA.debugLineNum = 655364;BA.debugLine="z.Col_Count=2";
mostCurrent._z._setcol_count((int) (2));
RDebugUtils.currentLine=655365;
 //BA.debugLineNum = 655365;BA.debugLine="z.Row_Count=3";
mostCurrent._z._setrow_count((int) (3));
RDebugUtils.currentLine=655366;
 //BA.debugLineNum = 655366;BA.debugLine="z.Padding=2dip";
mostCurrent._z._setpadding(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2)));
RDebugUtils.currentLine=655367;
 //BA.debugLineNum = 655367;BA.debugLine="z.StartingPoint=3";
mostCurrent._z._setstartingpoint((int) (3));
RDebugUtils.currentLine=655368;
 //BA.debugLineNum = 655368;BA.debugLine="z.SetLayout";
mostCurrent._z._setlayout();
RDebugUtils.currentLine=655369;
 //BA.debugLineNum = 655369;BA.debugLine="z.OptionsDeleteAll";
mostCurrent._z._optionsdeleteall();
RDebugUtils.currentLine=655370;
 //BA.debugLineNum = 655370;BA.debugLine="If z.OptionsAdd(\"Option #1\",\"1.png\",\"1n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #1","1.png","1n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("1# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655371;
 //BA.debugLineNum = 655371;BA.debugLine="If z.OptionsAdd(\"Option #2\",\"2.png\",\"2n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #2","2.png","2n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("2# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655372;
 //BA.debugLineNum = 655372;BA.debugLine="If z.OptionsAdd(\"Option #3\",\"3.png\",\"3n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #3","3.png","3n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("3# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655373;
 //BA.debugLineNum = 655373;BA.debugLine="If z.OptionsAdd(\"Option #4\",\"4.png\",\"4n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #4","4.png","4n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("4# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655374;
 //BA.debugLineNum = 655374;BA.debugLine="If z.OptionsAdd(\"Option #5\",\"5.png\",\"5n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #5","5.png","5n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("5# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655375;
 //BA.debugLineNum = 655375;BA.debugLine="If z.OptionsAdd(\"Option #6\",\"6.png\",\"6n.png\")=Fal";
if (mostCurrent._z._optionsadd("Option #6","6.png","6n.png")==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.LogColor("6# error",anywheresoftware.b4a.keywords.Common.Colors.Red);};
RDebugUtils.currentLine=655376;
 //BA.debugLineNum = 655376;BA.debugLine="z.OptionsLoad";
mostCurrent._z._optionsload();
RDebugUtils.currentLine=655378;
 //BA.debugLineNum = 655378;BA.debugLine="End Sub";
return "";
}
public static String  _z_click(String _text,int _no) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("z_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "z_click", new Object[] {_text,_no});
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Sub z_Click(Text As String, No As Int)";
RDebugUtils.currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="Msgbox(Text,No)";
anywheresoftware.b4a.keywords.Common.Msgbox(_text,BA.NumberToString(_no),mostCurrent.activityBA);
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="Log(Text &\" --- \"&No)";
anywheresoftware.b4a.keywords.Common.Log(_text+" --- "+BA.NumberToString(_no));
RDebugUtils.currentLine=983043;
 //BA.debugLineNum = 983043;BA.debugLine="End Sub";
return "";
}
}